"""
    Apideck

    The Apideck OpenAPI Spec: SDK Optimized  # noqa: E501

    The version of the OpenAPI document: 10.7.7
    Contact: support@apideck.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from apideck.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from apideck.exceptions import ApiAttributeError


def lazy_import():
    from apideck.model.currency import Currency
    from apideck.model.ecommerce_address import EcommerceAddress
    from apideck.model.ecommerce_discount import EcommerceDiscount
    from apideck.model.ecommerce_order_line_item import EcommerceOrderLineItem
    from apideck.model.ecommerce_order_status import EcommerceOrderStatus
    from apideck.model.linked_ecommerce_customer import LinkedEcommerceCustomer
    from apideck.model.tracking_item import TrackingItem
    globals()['Currency'] = Currency
    globals()['EcommerceAddress'] = EcommerceAddress
    globals()['EcommerceDiscount'] = EcommerceDiscount
    globals()['EcommerceOrderLineItem'] = EcommerceOrderLineItem
    globals()['EcommerceOrderStatus'] = EcommerceOrderStatus
    globals()['LinkedEcommerceCustomer'] = LinkedEcommerceCustomer
    globals()['TrackingItem'] = TrackingItem


class EcommerceOrder(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('payment_status',): {
            'None': None,
            'PENDING': "pending",
            'AUTHORIZED': "authorized",
            'PAID': "paid",
            'PARTIAL': "partial",
            'REFUNDED': "refunded",
            'VOIDED': "voided",
            'UNKNOWN': "unknown",
        },
        ('fulfillment_status',): {
            'None': None,
            'PENDING': "pending",
            'SHIPPED': "shipped",
            'PARTIAL': "partial",
            'DELIVERED': "delivered",
            'CANCELLED': "cancelled",
            'RETURNED': "returned",
            'UNKNOWN': "unknown",
        },
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'order_number': (str, none_type,),  # noqa: E501
            'currency': (Currency,),  # noqa: E501
            'discounts': ([EcommerceDiscount],),  # noqa: E501
            'sub_total': (str, none_type,),  # noqa: E501
            'shipping_cost': (str, none_type,),  # noqa: E501
            'coupon_discount': (str, none_type,),  # noqa: E501
            'total_discount': (str, none_type,),  # noqa: E501
            'total_tax': (str, none_type,),  # noqa: E501
            'total_amount': (str, none_type,),  # noqa: E501
            'refunded_amount': (str, none_type,),  # noqa: E501
            'status': (EcommerceOrderStatus,),  # noqa: E501
            'payment_status': (str, none_type,),  # noqa: E501
            'fulfillment_status': (str, none_type,),  # noqa: E501
            'payment_method': (str, none_type,),  # noqa: E501
            'customer': (LinkedEcommerceCustomer,),  # noqa: E501
            'billing_address': (EcommerceAddress,),  # noqa: E501
            'shipping_address': (EcommerceAddress,),  # noqa: E501
            'tracking': ([TrackingItem],),  # noqa: E501
            'line_items': ([EcommerceOrderLineItem],),  # noqa: E501
            'note': (str, none_type,),  # noqa: E501
            'custom_mappings': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}, none_type,),  # noqa: E501
            'created_at': (datetime, none_type,),  # noqa: E501
            'updated_at': (datetime, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'order_number': 'order_number',  # noqa: E501
        'currency': 'currency',  # noqa: E501
        'discounts': 'discounts',  # noqa: E501
        'sub_total': 'sub_total',  # noqa: E501
        'shipping_cost': 'shipping_cost',  # noqa: E501
        'coupon_discount': 'coupon_discount',  # noqa: E501
        'total_discount': 'total_discount',  # noqa: E501
        'total_tax': 'total_tax',  # noqa: E501
        'total_amount': 'total_amount',  # noqa: E501
        'refunded_amount': 'refunded_amount',  # noqa: E501
        'status': 'status',  # noqa: E501
        'payment_status': 'payment_status',  # noqa: E501
        'fulfillment_status': 'fulfillment_status',  # noqa: E501
        'payment_method': 'payment_method',  # noqa: E501
        'customer': 'customer',  # noqa: E501
        'billing_address': 'billing_address',  # noqa: E501
        'shipping_address': 'shipping_address',  # noqa: E501
        'tracking': 'tracking',  # noqa: E501
        'line_items': 'line_items',  # noqa: E501
        'note': 'note',  # noqa: E501
        'custom_mappings': 'custom_mappings',  # noqa: E501
        'created_at': 'created_at',  # noqa: E501
        'updated_at': 'updated_at',  # noqa: E501
    }

    read_only_vars = {
        'id',  # noqa: E501
        'custom_mappings',  # noqa: E501
        'created_at',  # noqa: E501
        'updated_at',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, *args, **kwargs):  # noqa: E501
        """EcommerceOrder - a model defined in OpenAPI

        Args:
            id (str): A unique identifier for an object.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            order_number (str, none_type): Order number, if any.. [optional]  # noqa: E501
            currency (Currency): [optional]  # noqa: E501
            discounts ([EcommerceDiscount]): [optional]  # noqa: E501
            sub_total (str, none_type): Sub-total amount, normally before tax.. [optional]  # noqa: E501
            shipping_cost (str, none_type): Shipping cost, if any.. [optional]  # noqa: E501
            coupon_discount (str, none_type): Coupon discount, if any.. [optional]  # noqa: E501
            total_discount (str, none_type): Total discount, if any.. [optional]  # noqa: E501
            total_tax (str, none_type): Total tax, if any.. [optional]  # noqa: E501
            total_amount (str, none_type): Total amount due.. [optional]  # noqa: E501
            refunded_amount (str, none_type): Refunded amount, if any.. [optional]  # noqa: E501
            status (EcommerceOrderStatus): [optional]  # noqa: E501
            payment_status (str, none_type): Current payment status of the order.. [optional]  # noqa: E501
            fulfillment_status (str, none_type): Current fulfillment status of the order.. [optional]  # noqa: E501
            payment_method (str, none_type): Payment method used for this order.. [optional]  # noqa: E501
            customer (LinkedEcommerceCustomer): [optional]  # noqa: E501
            billing_address (EcommerceAddress): [optional]  # noqa: E501
            shipping_address (EcommerceAddress): [optional]  # noqa: E501
            tracking ([TrackingItem]): [optional]  # noqa: E501
            line_items ([EcommerceOrderLineItem]): [optional]  # noqa: E501
            note (str, none_type): Note for the order.. [optional]  # noqa: E501
            custom_mappings ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}, none_type): When custom mappings are configured on the resource, the result is included here.. [optional]  # noqa: E501
            created_at (datetime, none_type): The date and time when the object was created.. [optional]  # noqa: E501
            updated_at (datetime, none_type): The date and time when the object was last updated.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """EcommerceOrder - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            order_number (str, none_type): Order number, if any.. [optional]  # noqa: E501
            currency (Currency): [optional]  # noqa: E501
            discounts ([EcommerceDiscount]): [optional]  # noqa: E501
            sub_total (str, none_type): Sub-total amount, normally before tax.. [optional]  # noqa: E501
            shipping_cost (str, none_type): Shipping cost, if any.. [optional]  # noqa: E501
            coupon_discount (str, none_type): Coupon discount, if any.. [optional]  # noqa: E501
            total_discount (str, none_type): Total discount, if any.. [optional]  # noqa: E501
            total_tax (str, none_type): Total tax, if any.. [optional]  # noqa: E501
            total_amount (str, none_type): Total amount due.. [optional]  # noqa: E501
            refunded_amount (str, none_type): Refunded amount, if any.. [optional]  # noqa: E501
            status (EcommerceOrderStatus): [optional]  # noqa: E501
            payment_status (str, none_type): Current payment status of the order.. [optional]  # noqa: E501
            fulfillment_status (str, none_type): Current fulfillment status of the order.. [optional]  # noqa: E501
            payment_method (str, none_type): Payment method used for this order.. [optional]  # noqa: E501
            customer (LinkedEcommerceCustomer): [optional]  # noqa: E501
            billing_address (EcommerceAddress): [optional]  # noqa: E501
            shipping_address (EcommerceAddress): [optional]  # noqa: E501
            tracking ([TrackingItem]): [optional]  # noqa: E501
            line_items ([EcommerceOrderLineItem]): [optional]  # noqa: E501
            note (str, none_type): Note for the order.. [optional]  # noqa: E501
            custom_mappings ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}, none_type): When custom mappings are configured on the resource, the result is included here.. [optional]  # noqa: E501
            created_at (datetime, none_type): The date and time when the object was created.. [optional]  # noqa: E501
            updated_at (datetime, none_type): The date and time when the object was last updated.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
